Package net.sf.saxon.expr

## Class ItemMappingIterator

- java.lang.Object
- - net.sf.saxon.expr.ItemMappingIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `SequenceIterator`, `LookaheadIterator`
  Direct Known Subclasses:
    `MultithreadedItemMappingIterator`

      public class ItemMappingIterator
      extends java.lang.Object
      implements SequenceIterator, LookaheadIterator, LastPositionFinder

  ItemMappingIterator applies a mapping function to each item in a sequence. The mapping function either returns a single item, or null (representing an empty sequence).

  This is a specialization of the more general MappingIterator class, for use in cases where a single input item never maps to a sequence of more than one output item.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ItemMappingIterator​(SequenceIterator base, ItemMappingFunction action)` | Construct an ItemMappingIterator that will apply a specified DummyItemMappingFunction to each Item returned by the base iterator.
    `ItemMappingIterator​(SequenceIterator base, ItemMappingFunction action, boolean oneToOne)` | Construct an ItemMappingIterator that will apply a specified ItemMappingFunction to each Item returned by the base iterator.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the iterator.
    `protected SequenceIterator` | `getBaseIterator()` | Get the base (input) iterator
    `int` | `getLength()` | Get the last position (that is, the number of items in the sequence).
    `protected ItemMappingFunction` | `getMappingFunction()` | Get the mapping function (the function applied to each item in the input sequence
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `boolean` | `isOneToOne()` | Ask whether this ItemMappingIterator is one-to-one: that is, for every input item, there is always exactly one output item.
    `Item` | `next()` | Get the next item in the sequence.
    `void` | `setOneToOne​(boolean oneToOne)` | Say whether this ItemMappingIterator is one-to-one: that is, for every input item, there is always exactly one output item.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `forEachOrFail, materialize`

- - ### Constructor Detail

    - #### ItemMappingIterator

          public ItemMappingIterator​(SequenceIterator base,
                                     ItemMappingFunction action)

      Construct an ItemMappingIterator that will apply a specified DummyItemMappingFunction to each Item returned by the base iterator.
      Parameters:
        `base` - the base iterator
        `action` - the mapping function to be applied.

    - #### ItemMappingIterator

          public ItemMappingIterator​(SequenceIterator base,
                                     ItemMappingFunction action,
                                     boolean oneToOne)

      Construct an ItemMappingIterator that will apply a specified ItemMappingFunction to each Item returned by the base iterator.
      Parameters:
        `base` - the base iterator
        `action` - the mapping function to be applied
        `oneToOne` - true if this iterator is one-to-one

  - ### Method Detail

    - #### setOneToOne

          public void setOneToOne​(boolean oneToOne)

      Say whether this ItemMappingIterator is one-to-one: that is, for every input item, there is always exactly one output item. The default is false.
      Parameters:
        `oneToOne` - true if this iterator is one-to-one

    - #### isOneToOne

          public boolean isOneToOne()

      Ask whether this ItemMappingIterator is one-to-one: that is, for every input item, there is always exactly one output item. The default is false.
      Returns:
        true if this iterator is one-to-one

    - #### getBaseIterator

          protected SequenceIterator getBaseIterator()

      Get the base (input) iterator
      Returns:
        the iterator over the input sequence

    - #### getMappingFunction

          protected ItemMappingFunction getMappingFunction()

      Get the mapping function (the function applied to each item in the input sequence
      Returns:
        the mapping function

    - #### hasNext

          public boolean hasNext()

      Description copied from interface: `LookaheadIterator`
      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

      This method must not be called unless the result of getProperties() on the iterator includes the property `SequenceIterator.Property.LOOKAHEAD`

      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items in the sequence

    - #### next

          public Item next()
                    throws XPathException

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator.
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      For example, the iterator returned by the unparsed-text-lines() function has a close() method that causes the underlying input stream to be closed, whether or not the file has been read to completion.

      Closing an iterator is important when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `SequenceIterator`

    - #### getLength

          public int getLength()
                        throws XPathException

      Description copied from interface: `LastPositionFinder`
      Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.Property.LAST_POSITION_FINDER`
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the number of items in the sequence
      Throws:
        `XPathException` - if an error occurs evaluating the sequence in order to determine the number of items

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.